package cc.smtweb.system.bpm.web.engine.dynPage;

import cc.smtweb.framework.core.exception.BizException;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.db.DbEngine;
import cc.smtweb.framework.core.db.EntityHelper;
import cc.smtweb.framework.core.db.cache.ModelTableCache;
import cc.smtweb.framework.core.db.vo.ModelTable;
import cc.smtweb.framework.core.mvc.service.AbstractCompProvider;
import cc.smtweb.framework.core.mvc.service.SqlNamedPara;
import cc.smtweb.system.bpm.web.design.form.define.PageDataset;
import cc.smtweb.system.bpm.web.design.form.define.PageDatasets;

/**
 * Created by Akmm at 2022/5/26 18:40
 */
public class DynPageProvider extends AbstractCompProvider {
    protected long pageId;
    protected PageDatasets datasets;

    //加载表单类数据集（单条）
    public SwMap loadData(SwMap filter, PageDataset pageDataSet) {
        return doGetData(pageDataSet.id, () -> {
            SqlNamedPara sqlPara = DynPageHelper.buildSelectSql(pageDataSet, filter);
            SwMap map = DbEngine.getInstance().queryEntityN(sqlPara.sql, sqlPara.mapParas, SwMap.class);
            if (map == null) {
                throw new BizException("没有找到指定数据（ds=" + pageDataSet.name + "）");
            }
            ModelTable masterTable = ModelTableCache.getInstance().get(pageDataSet.masterTable);
            EntityHelper.loadBeanText(masterTable.getName(), map, sqlPara.mapFieldAlias);
            DynPageHelper.setCalcFields(map, pageDataSet);
            return map;
        });
    }


}
